import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useState } from 'react';
import PropTypes from 'prop-types';
import { ToggleSwitchTypeRender } from './SwitchType/toggle';
import { SingleSwitchTypeRender } from './SwitchType/single';
import { SIZES, TYPES, SUPPORTED_KEYS } from './config';

var AtomSwitch = function AtomSwitch(props) {
  var initialValue = props.initialValue,
      disabled = props.disabled,
      onToggleCallback = props.onToggle,
      type = props.type;

  var _useState = useState(initialValue),
      isToggle = _useState[0],
      setIsToggle = _useState[1];

  var _useState2 = useState(false),
      isFocus = _useState2[0],
      setIsFocus = _useState2[1];

  var _useState3 = useState(false),
      isClick = _useState3[0],
      setIsClick = _useState3[1];

  var onBlur = function onBlur() {
    setIsFocus(false);
    setIsClick(false);
  };

  var onFocus = function onFocus() {
    setTimeout(function () {
      setIsFocus(true);
    }, 150);
  };

  var onClick = function onClick() {
    setIsClick(true);
  };

  var onToggle = function onToggle(forceValue) {
    if (disabled === true) return;
    var newIsToggle = forceValue !== undefined ? forceValue : !isToggle;
    setIsToggle(newIsToggle);
    onToggleCallback(newIsToggle);
  };

  var onKeyDown = function onKeyDown(ev) {
    if (disabled === true) return;

    if (SUPPORTED_KEYS.includes(ev.key)) {
      onToggleCallback();
      ev.preventDefault();
    }
  };

  var commonProps = _objectSpread({}, props, {
    isFocus: isFocus,
    isClick: isClick,
    isToggle: isToggle,
    onBlur: onBlur,
    onClick: onClick,
    onFocus: onFocus,
    onKeyDown: onKeyDown,
    onToggle: onToggle
  });

  return type === TYPES.SINGLE ? React.createElement(SingleSwitchTypeRender, commonProps) : React.createElement(ToggleSwitchTypeRender, commonProps);
};

AtomSwitch.displayName = 'AtomSwitch';
AtomSwitch.defaultProps = {
  disabled: false,
  initialValue: false,
  labelLeft: 'Off',
  labelRight: 'On',
  size: SIZES.DEFAULT,
  type: TYPES.TOGGLE
};
export default AtomSwitch;